<template>
  <Teleport to="body">
    <div v-if="isOpen" class="search-modal">
      <div class="search-modal-background" @click="closeModal"></div>
      <div class="search-modal-body">
        <div class="search-modal-body-header">
          <div class="search-icon">
            <font-awesome-icon icon="magnifying-glass" />
          </div>
          <form class="search-widget-form" @submit.prevent="performSearch">
            <input
              id="game-search-input"
              ref="searchInputRef"
              v-model="searchTerm"
              maxlength="100"
              type="text"
              name=""
              :placeholder="$t('Search All Games')"
              class="search-input"
            />
            <button
              id="game-search-submit-button"
              type="submit"
              class="button--t4 whitespace-nowrap h-[40px] search-button"
            >
              <font-awesome-icon icon="search" class="w-4 h-4 pr-1" />
              {{ $t("search") }}
            </button>
            <button type="button" class="close-icon" @click="closeModal">
              <font-awesome-icon icon="xmark" />
            </button>
          </form>
        </div>
        <div class="search-modal-body-games">
          <div v-if="showNoGameFound" class="games_not_found">
            <img
              :src="
                getAssetImage('assets/theme/black_modern_1/images/ghost.png')
              "
              class="mr-2"
            />
            {{ $t("sorry_no_game_found") }}
          </div>
          <div v-if="showSearchResults" class="search-widget-game-list">
            <div v-for="game in games" :key="game.GameId" class="game-item">
              <div class="game-img">
                <el-image :src="game.GameIconUrl" lazy />
              </div>
              <div class="game-info">
                <div class="game-name">{{ game.EnglishGameName }}</div>
                <div class="game-provider">{{ game.GameProviderName }}</div>
                <div class="game-tags">
                  <span v-if="game.IsHotGame" class="game-new">{{
                    $t("hot")
                  }}</span>
                  <span
                    v-if="game.IsNewGame && !game.IsHotGame"
                    class="game-new"
                    >{{ $t("new") }}</span
                  >
                </div>
              </div>
              <div class="game-buttons">
                <button @click="handlePlayButtonClick(game)">
                  <Button variant="Accent">{{ $t("play_now") }}</Button>
                </button>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </Teleport>
</template>

<script setup lang="ts">
import { Search } from "@element-plus/icons-vue";
import Button from "../ui/Button.client.vue";
import { store } from "@/store";
import { handleGameEntryOpenWindow } from "@/composables/useTheme";
import commonHelper from "@/utils/commonHelper";
import { gameStore } from "~~/store/game";
import { IGameBsi } from "~~/models/bsiGameList";
import {
  EPlayerSearchGameDevice,
  IPlayerSearchGameRequest,
} from "~~/models/playerSearchGame";
import apis from "~~/utils/apis";
import { IGame } from "~~/models/IGetPlayableGamesResponse";

const props = defineProps({
  isOpen: {
    type: Boolean,
    required: true,
  },
});
const emit = defineEmits(["close"]);
const router = useRouter();
const searchTerm = ref("");
const searchInputRef = ref();
const { getAssetImage } = commonHelper;
const { dispatchGameSearchEvent } = useCustomEvents();

const closeModal = () => {
  emit("close");
  searchTerm.value = "";
};
const allGames = ref(gameStore.state.games);
const games = ref<IGameBsi[]>([]);
const showNoGameFound = ref<boolean>(
  searchTerm.value.length > 0 && games.value.length <= 0
);
const showSearchResults = ref<boolean>(
  searchTerm.value.length > 0 && games.value.length > 0
);

const callSearchRecordApi = () => {
  const gameSearchTerm = searchTerm.value;
  if (gameSearchTerm && gameSearchTerm.length > 0) {
    const isDesktop = useIsDesktop();
    const deviceType = isDesktop
      ? EPlayerSearchGameDevice.Desktop
      : EPlayerSearchGameDevice.Mobile;
    const payload: IPlayerSearchGameRequest = {
      WebId: store.state.webId ?? 0,
      Username: store.state.username ?? "",
      SearchContent: gameSearchTerm,
      SearchPage: window.location.toString(),
      DeviceType: deviceType,
      OnlineId: Number(localStorage.getItem("onlineId") ?? 0),
    };
    apis.getPlayerSearchGame(payload);
  }
};

const performSearch = () => {
  const noSearch = !searchTerm.value || searchTerm.value.trim().length <= 0;
  showNoGameFound.value = false;
  showSearchResults.value = false;
  if (noSearch) {
    games.value = [];
  } else {
    dispatchGameSearchEvent(searchTerm.value);
    games.value = allGames.value.filter((game) => {
      const term = searchTerm.value.toLowerCase();
      const isNameMatches =
        game.EnglishGameName &&
        game.EnglishGameName.toLowerCase().includes(term);
      return isNameMatches;
    });
    if (games.value.length === 0) {
      showNoGameFound.value = true;
    } else {
      showSearchResults.value = true;
    }
    callSearchRecordApi();
  }
};

const focusInput = async () => {
  await nextTick();
  searchInputRef.value.focus();
};

const controlBodyScroll = (option: "lock" | "unlock") => {
  const body = document.querySelector("body");
  if (!body) return;
  if (option === "lock") {
    body.classList.add("lock-body-scroll");
    return;
  }
  body.classList.remove("lock-body-scroll");
};
const handleEsc = (evt: KeyboardEvent) => {
  if (evt.keyCode === 27) {
    closeModal();
  }
};
onBeforeUnmount(() => {
  controlBodyScroll("unlock");
});
watch(
  () => props.isOpen,
  () => {
    if (props.isOpen) {
      showNoGameFound.value = false;
      showSearchResults.value = false;
      controlBodyScroll("lock");
      focusInput();
      document.addEventListener("keyup", handleEsc);
      return;
    }
    controlBodyScroll("unlock");
    document.removeEventListener("keyup", handleEsc);
  }
);

const handlePlayButtonClick = (game: IGame) => {
  if (!store.state.auth) {
    router.push("/register");
  } else {
    handleGameEntryOpenWindow(game, 850, 850);
  }
  closeModal();
};
</script>
<style scoped>
.search-modal {
  position: fixed;
  z-index: 9999;
  top: 0;
  left: 0;
  width: 100vw;
  height: 100vh;
}

.search-modal-background {
  position: fixed;
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;
  background: rgba(47, 56, 78, 0.68); /* unique */
  -webkit-backdrop-filter: blur(20px);
  backdrop-filter: blur(20px);
}

.search-input:focus::placeholder {
  color: transparent;
}

.search-modal-body {
  position: relative;
  z-index: 10;
  width: 100%;
  max-width: 704px;
  margin: 88px auto 0;
}

.search-modal-body-header {
  display: -webkit-box;
  display: -ms-flexbox;
  display: flex;
  -webkit-box-pack: justify;
  -ms-flex-pack: justify;
  justify-content: space-between;
  -webkit-box-align: center;
  -ms-flex-align: center;
  align-items: center;
}

.search-modal-body-header .search-icon,
.search-modal-body-header .close-icon {
  top: 12px;
}

.search-modal-body-header .search-icon svg,
.search-modal-body-header .close-icon svg {
  max-width: 16px;
  max-height: 16px;
  width: 100%;
  height: 100%;
}

.search-modal-body-header .search-icon {
  left: 12px;
}

.search-modal-body-header .search-icon,
.search-modal-body-header .close-icon {
  position: absolute;
  width: 40px;
  height: 40px;
  display: -webkit-box;
  display: -ms-flexbox;
  display: flex;
  -webkit-box-pack: center;
  -ms-flex-pack: center;
  justify-content: center;
  -webkit-box-align: center;
  -ms-flex-align: center;
  align-items: center;
  color: var(--text2);
}

.search-modal-body-header .search-widget-form {
  width: 100%;
  padding: 12px;
  background: var(--background2);
  border-radius: 8px;
  -webkit-box-shadow: var(--box-shadow-inset);
  box-shadow: var(--box-shadow-inset);
  display: flex;
  flex-direction: column;
  gap: 0.5rem;
}

@media only screen and (min-width: 640px) {
  .search-modal-body-header .search-widget-form {
    flex-direction: row;
  }
}

.search-modal-body-header .search-widget-form input:focus,
.search-modal-body-header .search-widget-form input:focus-visible {
  border-color: transparent;
  outline: none;
}
.search-modal-body-header .search-widget-form input {
  /* width: 85%; */
  padding-left: 40px;
  padding-right: 40px;
  max-width: 100%;
}
@media only screen and (min-width: 640px) {
  .search-modal-body-header .search-widget-form input {
    width: calc(85% - 0.5rem);
  }
  .search-modal-body-header .search-button {
    min-width: 15%;
  }
  .search-modal-body-header .close-icon {
    right: 0;
    left: calc(85% - 1rem - 40px);
  }
}
input[type="text"]:focus,
input[type="password"]:focus,
input[type="email"]:focus,
input[type="tel"]:focus,
input[type="search"]:focus,
textarea:focus {
  -webkit-box-shadow: var(--box-shadow-inset);
  box-shadow: var(--box-shadow-inset);
  border: 1px solid var(--accent-color);
}
input[type="text"],
input[type="password"],
input[type="email"],
input[type="tel"],
input[type="search"],
textarea {
  width: 300px;
  height: 40px;
  padding: 8px 16px;
  font-family: "Roboto", sans-serif;
  font-size: 14px;
  font-weight: normal;
  line-height: 20px;
  color: var(--text);
  background: var(--background-body);
  border: 1px solid transparent;
  -webkit-box-shadow: var(--box-shadow-inset);
  box-shadow: var(--box-shadow-inset);
  border-radius: 8px;
  -webkit-box-sizing: border-box;
  box-sizing: border-box;
  -webkit-transition: all 0.4s;
  transition: all 0.4s;
  -ms-flex-negative: 0;
  flex-shrink: 0;
}
.search-modal-body-header .search-icon,
.search-modal-body-header .close-icon {
  top: 12px;
}

.search-modal-body-header .close-icon {
  right: 12px;
  cursor: pointer;
  font-size: 14px;
}

.search-modal-body-header .search-icon,
.search-modal-body-header .close-icon {
  position: absolute;
  width: 40px;
  height: 40px;
  display: -webkit-box;
  display: -ms-flexbox;
  display: flex;
  -webkit-box-pack: center;
  -ms-flex-pack: center;
  justify-content: center;
  -webkit-box-align: center;
  -ms-flex-align: center;
  align-items: center;
}

.search-modal-body-games {
  position: absolute;
  z-index: 1;
  left: 0;
  top: calc(100% + 8px);
  width: 100%;
}

.search-modal-body-games .games_not_found,
.search-modal-body-games .search-widget-game-list {
  max-width: 100%;
  min-height: 80px;
  padding: 12px;
  background: var(--background2);
  -webkit-box-shadow: var(--box-shadow-simle);
  box-shadow: var(--box-shadow-simle);
  border-radius: 8px;
}

.search-modal-body-games .games_not_found {
  display: -webkit-box;
  display: -ms-flexbox;
  display: flex;
  -webkit-box-align: center;
  -ms-flex-align: center;
  align-items: center;
}
.search-modal-body-games .games_not_found,
.search-modal-body-games .search-widget-game-list {
  max-width: 100%;
  min-height: 80px;
  padding: 12px;
  background: var(--background2);
  -webkit-box-shadow: var(--box-shadow-simle);
  box-shadow: var(--box-shadow-simle);
  border-radius: 8px;
}
.search-modal-body-games .search-widget-game-list {
  max-height: 348px;
  overflow: auto;
}

.search-modal-body-games .game-item:not(:last-child) {
  margin-bottom: 12px;
}

.search-modal-body-games .game-item {
  display: -webkit-box;
  display: -ms-flexbox;
  display: flex;
  -webkit-box-pack: start;
  -ms-flex-pack: start;
  justify-content: flex-start;
  -webkit-box-align: center;
  -ms-flex-align: center;
  align-items: center;
}

.search-modal-body-games .game-img {
  background-size: cover;
}
.search-modal-body-games .game-img {
  width: 80px;
  border-radius: 6px;
  -ms-flex-negative: 0;
  flex-shrink: 0;
  margin-right: 24px;
  background-size: contain;
}
.search-modal-body-games .game-img :deep(.el-image__error) {
  width: 80px;
  height: 60px;
}

.game-info {
  width: 100%;
}

.search-modal-body-games .game-info {
  display: -webkit-box;
  display: -ms-flexbox;
  display: flex;
  -webkit-box-orient: vertical;
  -webkit-box-direction: normal;
  -ms-flex-direction: column;
  flex-direction: column;
  width: 160px;
  text-align: left;
}
.search-modal-body-games .game-info .game-name {
  line-height: 20px;
  font-size: 16px;
  color: var(--text);
  width: 100%;
}
.game-info .game-name {
  font-weight: bold;
  font-size: 24px;
  line-height: 32px;
  color: var(--text);
  margin-bottom: 4px;
}
.search-modal-body-games .game-info .game-provider {
  font-size: 12px;
  line-height: 18px;
  color: var(--text2);
}
.search-modal-body-games .game-buttons {
  display: -webkit-box;
  display: -ms-flexbox;
  display: flex;
  -webkit-box-align: center;
  -ms-flex-align: center;
  align-items: center;
  margin-left: auto;
}
@media (max-width: 480px) {
  .search-modal-body-games .game-item {
    -ms-flex-wrap: wrap;
    flex-wrap: wrap;
  }

  .search-modal-body-games .game-item:not(:last-of-type) {
    margin-bottom: 24px;
    border-bottom: 1px solid var(--border-color);
  }
  .search-modal-body-games .game-img {
    margin-right: 16px;
  }
  .search-modal-body-games .game-info {
    width: calc(100% - 96px);
  }
  .search-modal-body-games .game-buttons {
    width: calc(100% + 12px);
    margin: 16px -6px 24px;
  }
}

@media (max-width: 767px) {
  .search-modal {
    right: 32px;
    padding: 0 16px;
  }
  .search-modal-body-header {
    width: 100%;
  }

  .search-modal-body-header input {
    width: 100%;
  }
}

.search-modal-body-games .search-widget-game-list::-webkit-scrollbar {
  width: 5px;
}
.search-modal-body-games .search-widget-game-list::-webkit-scrollbar-thumb {
  background: var(--border-color);
  border-radius: 10px;
}
.search-modal-body-games .search-widget-game-list::-webkit-scrollbar-track {
  -webkit-box-shadow: inset 0 0 5px transparent;
  box-shadow: inset 0 0 5px transparent;
  border-radius: 10px;
}
</style>

<style>
body.lock-body-scroll {
  height: 100vh;
  width: 100vw;
  overflow: hidden;
}
/* Hide scrollbar for Chrome, Safari and Opera */
body.lock-body-scroll::-webkit-scrollbar {
  display: none;
}

/* Hide scrollbar for IE, Edge and Firefox */
body.lock-body-scroll {
  -ms-overflow-style: none; /* IE and Edge */
  scrollbar-width: none; /* Firefox */
}
</style>
